'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _autoprefix = require('autoprefix');

var _autoprefix2 = _interopRequireDefault(_autoprefix);

function isStyle(node) {
  return node.name.name === 'style';
}

function isString(value) {
  return typeof value === 'string';
}

function propertiesToObject(properties) {
  return Object.keys(properties).map(function (k) {
    return { key: properties[k].key.name, value: properties[k].value.value };
  }).reduce(function (p, _ref) {
    var key = _ref.key;
    var value = _ref.value;
    return _extends({}, p, _defineProperty({}, key, value));
  }, {});
}

exports['default'] = function (_ref2) {
  var Plugin = _ref2.Plugin;
  var t = _ref2.types;

  function getValue(value) {
    return isString(value) ? t.literal(value) : t.arrayExpression(value.map(t.literal));
  }

  function prefixStyle(node) {
    var prefixed = (0, _autoprefix2['default'])(propertiesToObject(node.expression.properties));

    return t.objectExpression(Object.keys(prefixed).map(function (k) {
      return t.property('init', t.identifier(k), getValue(prefixed[k]));
    }));
  }

  return new Plugin('react-prefix-styles', {
    metadata: {
      group: 'builtin-pre'
    },

    visitor: {
      JSXAttribute: function JSXAttribute(node) {
        if (isStyle(node)) {
          node.value = prefixStyle(node.value);
        }
      }
    }
  });
};

module.exports = exports['default'];